#!/usr/local/OpenOffice.org1.1.3/program/python

# GoBlueDCS
#
# Document converter using pyuno.
# (c) GPL 2004 by:
#             Georg Gogo. BERNHARD
#             Hans Peter Neumeier
#             Bluedynamics GmbH.
#
# !!!HINT!!! You don't need give the option '-c' if you start OO.org with:
#    /usr/local/OpenOffice.org1.1.3/program/soffice "-accept=socket,host=localhost,port=2002;urp"

import uno, unohelper, os, os.path, tempfile, zipfile, glob, tempfile
import SimpleXMLRPCServer, SocketServer

import utils
#from interfaces.IBlueDCSServer import IBlueDCSServer

type2app={    
    'com.sun.star.sheet.SpreadsheetDocument':'calc',
    'com.sun.star.text.GenericTextDocument':'writer', 
    'com.sun.star.text.TextDocument':'writer',
    'com.sun.star.drawing.DrawingDocument':'draw',
    'com.sun.star.presentation.PresentationDocument':'impress',
}
    

export_filters = {
    'calc':
        {

             "SXC"   :["SXC",0],
             "STC"   :["STC","calc_StarOffice_XML_Calc_Template"],
             "PDF"   :["PDF","calc_pdf_Export"],
             "XLS97" :["XLS","MS Excel 97"],
             "XLS97V":["XLS","MS Excel 97 Vorlage/Template"],
             "XLS95" :["XLS","MS Excel 95"],
             "XLS95V":["XLS","MS Excel 95 Vorlage/Template"],
             "XLS50" :["XLS","MS Excel 5.0/95"],
             "XLS50V":["XLS","MS Excel 5.0/95 Vorlage/Template"],
#                     "CXLS40" :["XLS","MS Excel 4.0"],
#                     "CXLS40V":["XLS","MS Excel 4.0 Vorlage/Template"],
             "CSV"   :["CSV","Text - txt - csv (StarCalc)"],
#                     "CWKS"   :["WKS","Lotus"],
             "DIF"   :["DIF","DIF"],
             "SYLK"  :["SYLK","SYLK"],
             "DBF"   :["DBF","dBase"],
             "HTML"  :["HTML","HTML (StarCalc)"],
             },
        
    'impress':{
             "SXI" :["SXI",0],
             "STI" :["STI","impress_StarOffice_XML_Impress_Template"],
             "PDF" :["PDF","impress_pdf_Export"],
             "SWF" :["SWF","impress_flash_Export"],
             "PPT" :["PPT","MS PowerPoint 97"],
             "PPTV":["PPT","MS PowerPoint 97 Vorlage"],
             "HTML" :["SWF","impress_flash_Export"],
#             "HTML":["HTML","impress_html_Export"],
             },
        
##    'draw':{
##
##             "SXI" :["SXI",0],
##             "STI" :["STI","draw_StarOffice_XML_Draw_Template"],
##             "PDF" :["PDF","draw_pdf_Export"],
##             "SWF" :["SWF","draw_flash_Export"],
##             "HTML":["HTML","draw_html_Export"]
##             },
        
    'writer':{
             "SXW"   :["SXW",0],
             "STW"   :["STW","writer_StarOffice_XML_Writer_Template"],
             "PDF"   :["PDF","writer_pdf_Export"],
             "DOC60" :["DOC","MS Winword 6.0"],
             "DOC97" :["DOC","MS Word 97"],
#                     "WDOC97V":["DOC","MS Word 97 Vorlage"],
             "DOC95" :["DOC","MS Word 95"],
#                     "WDOC95V":["DOC","MS Word 95 Vorlage"],
#                     "WDOC03" :["DOC","Microsoft Word 2003 XML"],
             "TXT"   :["TXT","Text"],
             "RTF"   :["RTF","Rich Text Format"],
             "HTML"  :["HTML","HTML (StarWriter)"],
#                     "WXHTML" :["XHTML","XHTML File"],
#                     "WXMLF"  :["XML","Flat XML File"],
#                     "WXMLDB" :["XML","DocBook File"],
            },
    }
    
def getApp4Doc(doc):
    names=doc.getSupportedServiceNames()
    print 'servicenames:',names
    for name in names:
        if type2app.has_key(name):
            return type2app[name]
        
    return None


class SimpleThreadedXMLRPCServer(SocketServer.ThreadingMixIn, SimpleXMLRPCServer.SimpleXMLRPCServer):
    pass


#class GoBlueDCSXMLRPCServer :
class GoBlueDCSXMLRPCServer (SimpleXMLRPCServer.SimpleXMLRPCServer) :

#    __implements__=(IBlueDCSServer,)

    def __init__(self, port=8888, OOo_port=2002) :
        """
        Constructor method for GoBlueDCS objects.
        This method can be called with a connection string, that has
        the form "socket,host=localhost,port=2002"
        """

        self.connection = "socket,host=localhost,port=%s" % OOo_port
        self.server = SimpleThreadedXMLRPCServer(('',int(port)))
#        self.server = SimpleXMLRPCServer.SimpleXMLRPCServer(xmlrpc_connect)
        self.server.register_function(self.convert)
        self.server.register_function(self.getImportFilters)
        self.server.register_function(self.getExportFilters)

    def start(self):
        self.server.serve_forever()




    def unzipdir(self, dirname) :
        """
        Unpacks alls archives from a folder to a temporary dir.
        """
                                                                                            
        print "Unpacking all archives in", dirname

        tempdir = tempfile.mktemp()
        print "                         ", tempdir
        os.makedirs(tempdir)

        for file in glob.glob(os.path.join(dirname, '*')) :
            print " Unpacking archive", file
            zip = zipfile.ZipFile(file, 'r')
            for filename in zip.namelist() :
                print "  Unpacking file", filename
                data = zip.read(filename)
                outfile = open(os.path.join(tempdir, filename), 'wb')
                outfile.write(data)
                outfile.close()
            zip.close()

        return tempdir


    def convert(self, inputblob, exportfilter, inputname, outputname='outfile', zipped=1) :
        """
        This method takes a 'blob' as an input, which is the content
        of a OpenOffice.org Component encded in base64. The exportfilter will define
        the format of the output, which is returned as a 'blob' as
        well. The parameter zipped decides wether the output file(s)
        should be zipped, which is mandatory for the WHTML output
        filter.
        """

        print ".convert() called."
        
        from time import time
        t=time()

        inputblob=inputblob.decode('base64')
        
        print "Connecting to OpenOffice.org.StarOffice process."
        # Connect to star office
        localContext = uno.getComponentContext()
        resolver = localContext.ServiceManager.createInstanceWithContext("com.sun.star.bridge.UnoUrlResolver", localContext)
        url = "uno:" + self.connection + ";urp;StarOffice.ComponentContext"
        print 'UNO Url:',url
        ctx = resolver.resolve(url)
        smgr = ctx.ServiceManager
        desktop = smgr.createInstanceWithContext("com.sun.star.frame.Desktop", ctx)
        

        print "Creating temporary directories"
        # create temporary directories
        tdirname = tempfile.mktemp() #.replace('@', '_')
        os.makedirs(tdirname)

        # create input directory
        idirname = os.path.join(tdirname, 'input')
        ifilename = os.path.join(idirname, inputname)
        ibasename = os.path.basename(ifilename)
        os.makedirs(idirname)

        # create output directory
        odirname = os.path.join(tdirname, 'output')
        ofilename = os.path.join(odirname, outputname)
        obasename = os.path.basename(ofilename)
        os.makedirs(odirname)

        # write input file to input directory
        ifile = open(ifilename, 'wb')
        ifile.write(inputblob)
        ifile.close()

#               ofilename = ofilename + '.' + filters[exportfilter][0]
        inputparams = (ifilename, 0)
        outputparams = (ofilename, exportfilter)

        print "Starting conversion for:"
        print "ifilename=", ifilename
        print "ibasename=", ibasename
        print "idirname=", idirname
        print "ifile=", ifile
        print "ofilename=", ofilename
        print "obasename=", obasename
        print "odirname=", odirname

        if self.do_convert(smgr, desktop, inputparams, outputparams) :
            print "Conversion ERROR!"
            print "*****"
            return 1

        # return a blob
        if zipped or len(glob.glob(os.path.join(odirname,'*'))) :
            print "convert will return a zipped blob"
            res=self.zipdir(odirname)
        else :
            ofile = open(ofilename, 'rb')
            outblob = ofile.read()
            ofile.close()
            res=outblob

        print 'elapsed time:',time()-t
        return res.encode('base64')

    def zipdir(self, dirname) :
        """
        Puts all files in the directory into a zip archive and returns its content
        """

        print ".zipdir() called."
        print "Creating zip file from directory", dirname

        ziptemp = tempfile.mktemp('zip')
        zip = zipfile.ZipFile(ziptemp, 'w')
        for file in glob.glob(os.path.join(dirname,'*')) :
            print " Writing", file, os.path.basename(file)
            zip.write(file, os.path.basename(file))
        zip.close()

        print "Creation of zip archive done"

        ofile = open(ziptemp, 'rb')
        outblob = ofile.read()
        ofile.close()

        print "Returning blob (%s...)." % (repr(outblob)[:10])

        return outblob



    def do_convert(self, smgr, desktop, inputfile, outputfile):
        """
        Converts a file from one format to another
        """

        print ".do_convert() called."

        import uno, unohelper, sys, os
        from com.sun.star.beans import PropertyValue
        from com.sun.star.uno import Exception as UnoException
        from com.sun.star.connection import NoConnectException as UnoNoConnectException
        from com.sun.star.lang import DisposedException as UnoDisposedException
        outputfile=list(outputfile)

        source, importFilter = inputfile

        print "Converting", inputfile
        print "          ", outputfile

        try:
            cwd = unohelper.systemPathToFileUrl(os.getcwd())
            if importFilter == 0:
                inProps = PropertyValue("Hidden" , 0 , True, 0),
            else:
                inProps = PropertyValue("Hidden", 0, True, 0), PropertyValue("FilterName", 0, importFilter, 0)
#            exportOptions = PropertyValue("FilterName", 0, 'HTML (StarCalc) ', 0),
            sourceUrl  = uno.absolutize(cwd, unohelper.systemPathToFileUrl(source))
            doc = desktop.loadComponentFromURL(sourceUrl , "_blank", 0, inProps)

            # prepare conversion parameters
            filters = self.getExportFilters(doc)
            exportFilter = filters[outputfile[1]][1]
            destinationdir=os.path.split(outputfile[0])[0]
            print 'outputfile:',outputfile
            if exportFilter=='impress_flash_Export':
                destination=os.path.join(destinationdir,'index.swf')
            else:
                destination = outputfile[0]
                
            destinationUrl = uno.absolutize(cwd, unohelper.systemPathToFileUrl(destination))
            exportOptions = PropertyValue("FilterName", 0, exportFilter, 0),
            print 'importFilter:',importFilter
            print 'exportFilter:',exportFilter
            print "destinationUrl", destinationUrl
            print 'exportOptions:', len(exportOptions), exportOptions
            doc.storeToURL(destinationUrl, exportOptions)
            if exportFilter=='impress_flash_Export':
                ind=open(os.path.join(destinationdir,'index.html'),'w')
                ind.write('''<html><body><object width="550" height="400">
<param name="movie" value="index.swf">
<embed src="index.swf" width="550" height="400">
</embed>

</object>


<a href="index.swf"> view fullscreen </a>
</body></html>''')
                ind.close()
                
        except UnoException, e:
            sys.stderr.write("\nUno-Error (" + repr(e.__class__)+") :" + e.Message + "\n" +
                    " ImportFilter: " + str(importFilter) + "\n" +
                    " ExportFilter: " + str(exportFilter) + "\n")
                    
            raise
        except UnoDisposedException, e:
            sys.stderr.write("\nUnexpected Uno-Error (" + repr(e.__class__)+") :" + e.Message + "\n" +
                    " ImportFilter: " + str(importFilter) + "\n" +
                    " ExportFilter: " + str(exportFilter) + "\n")
            raise
        except Exception,e:
            sys.stderr.write("\nUnexpected Error while converting!\n" +
                    " ImportFilter: " + str(importFilter) + "\n" +
                    " ExportFilter: " + str(exportFilter) + "\n")
            print >>sys.stderr,e
            raise

        return 0


    def getImportFilters(self):
        """Returns a dicionary of the available import filters"""

        import_filters = {"WSXW":["SXW",0],
             "WSTW":["STW",0],
             "WDOC":["DOC",0],
             "WTXT":["TXT",0],
             "WRTF":["RTF","Rich Text Format"],
# not tried #         "WSGF":["SGF","SGF - StarOffice Writer SGF"],

             "CSXC" :["SXC",0],
             "CXLS" :["XLS",0],
#                     "CCSV" :["CSV",0],
# not tried #         "CWKS" :["WKS","Lotus"],
#                     "CDIF" :["DIF","DIF"],
             "CSYLK":["SLK","SYLK"],
#                     "CDBF" :["DBF","dBase"],
             "CHTML":["HTML","HTML (StarCalc)"],
# not tried #         "CRTF" :["RTF","Rich Text Format (StarCalc)"],

             "ISXI" :["SXI",0],
             "ISTI" :["STI","impress_StarOffice_XML_Impress_Template"],
             "IPPT" :["PPT","MS PowerPoint 97"],
             "IPPTV":["PPT","MS PowerPoint 97 Vorlage"],
             "ISXD" :["SXD","impress_StarOffice_XML_Draw"],
             "ISTD" :["STD","impress_StarOffice_XML_Draw"],

             "DSXD":["SXD",0],
             "DSTD":["STD",0],
# not tried #         "DEMF":["EMF","EMF - MS Windows Metafile"],
# not tried #         "DMET":["MET","MET - OS/2 Metafile"],
# not tried #         "DDXF":["DXF","DXF - AutoCAD Interchange"],
             "DSDA":["SDA","StarDraw 3.0"],
             "DSDD":["SDD","StarDraw 5.0"],
             "DVOR":["VOR","StarDraw 3.0 Vorlage"]}
# not tried #         "DSGV":["SGV","SGV - StarDraw 2.0"],
# not tried #         "DEPS":["EPS","EPS - Encapsulated PostScript"],
# not tried #         "DPCT":["PCT","PCT - Mac Pict"]}

        return import_filters


    def getExportFilters(self, doc):
        """Returns a dictionary of the available export filters"""

        app=getApp4Doc(doc)
        
        return export_filters[app]



if __name__ == "__main__" :

    print "BlueDCS SimpleThreadedXMLRPCServer"
    print "Will now start serving..."
    s = GoBlueDCSXMLRPCServer()
